import * as i0 from '@angular/core';
import { Component, ViewChild, Input, ContentChildren, ViewChildren, HostBinding, HostListener, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i2$1 from '@angular/cdk/portal';
import { DomPortal, PortalModule } from '@angular/cdk/portal';
import { BsCardModule } from '@mintplayer/ng-bootstrap/card';
import * as i4 from '@mintplayer/ng-bootstrap/splitter';
import { BsSplitterModule } from '@mintplayer/ng-bootstrap/splitter';
import * as i5 from '@mintplayer/ng-bootstrap/tab-control';
import { BsTabControlModule } from '@mintplayer/ng-bootstrap/tab-control';
import * as i3 from '@mintplayer/ng-bootstrap/instance-of';
import { BsInstanceOfModule } from '@mintplayer/ng-bootstrap/instance-of';
import { BehaviorSubject, Subject, takeUntil } from 'rxjs';
import * as i1 from '@angular/cdk/overlay';

class BsDockPanelComponent {
    constructor() {
        this.panelId = '';
        // this.contentPortal = new DomPortal(this.element.nativeElement);
    }
    ngAfterViewInit() {
        // console.log('attach dockpanel', this.element.nativeElement);
        this.headerPortal = new DomPortal(this.headerElement.nativeElement);
        this.contentPortal = new DomPortal(this.contentElement.nativeElement);
    }
}
BsDockPanelComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPanelComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
BsDockPanelComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.5", type: BsDockPanelComponent, selector: "bs-dock-panel", inputs: { panelId: "panelId" }, viewQueries: [{ propertyName: "headerElement", first: true, predicate: ["headerElement"], descendants: true }, { propertyName: "contentElement", first: true, predicate: ["contentElement"], descendants: true }], ngImport: i0, template: "<!-- <bs-split-panel> -->\n<div #headerElement class=\"dock-header\">\n    <ng-content select=\"bs-dock-panel-header\"></ng-content>\n</div>\n<div #contentElement>\n    <ng-content></ng-content>\n</div>\n<!-- </bs-split-panel> -->", styles: [".dock-header{padding:var(--bs-nav-link-padding-y) var(--bs-nav-link-padding-x);margin:calc(-1 * var(--bs-nav-link-padding-y)) calc(-1 * var(--bs-nav-link-padding-x))}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPanelComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-panel', template: "<!-- <bs-split-panel> -->\n<div #headerElement class=\"dock-header\">\n    <ng-content select=\"bs-dock-panel-header\"></ng-content>\n</div>\n<div #contentElement>\n    <ng-content></ng-content>\n</div>\n<!-- </bs-split-panel> -->", styles: [".dock-header{padding:var(--bs-nav-link-padding-y) var(--bs-nav-link-padding-x);margin:calc(-1 * var(--bs-nav-link-padding-y)) calc(-1 * var(--bs-nav-link-padding-x))}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { headerElement: [{
                type: ViewChild,
                args: ['headerElement']
            }], contentElement: [{
                type: ViewChild,
                args: ['contentElement']
            }], panelId: [{
                type: Input
            }] } });

class BsDockPane {
}

class BsTabGroupPane extends BsDockPane {
    constructor(data) {
        super();
        this.panes = [];
        Object.assign(this, data);
    }
}

class BsDocumentHost extends BsDockPane {
    constructor(data) {
        super();
        Object.assign(this, data);
    }
}

var EPaneType;
(function (EPaneType) {
    EPaneType[EPaneType["documentHost"] = 1] = "documentHost";
    EPaneType[EPaneType["splitPane"] = 2] = "splitPane";
    EPaneType[EPaneType["contentPane"] = 3] = "contentPane";
    EPaneType[EPaneType["tabGroupPane"] = 4] = "tabGroupPane";
})(EPaneType || (EPaneType = {}));

class BsSplitPane extends BsDockPane {
    constructor(data) {
        super();
        this.orientation = 'horizontal';
        this.panes = [];
        Object.assign(this, data);
    }
}

class BsContentPane extends BsDockPane {
    constructor(data) {
        super();
        Object.assign(this, data);
    }
}

class BsDockPaneRendererComponent {
    constructor(element) {
        this.paneTypes = EPaneType;
        this.BsDocumentHostType = BsDocumentHost;
        this.BsTabGroupType = BsTabGroupPane;
        this.BsSplitterType = BsSplitPane;
        this.BsContentPaneType = BsContentPane;
        //#region Layout
        this.layout$ = new BehaviorSubject(null);
        // this.layoutType$ = this.layout$.pipe<EPaneType | null>(map((layout) => {
        //   if (layout === null) {
        //     return null;
        //   } else if (layout instanceof BsDocumentHost) {
        //     return EPaneType.documentHost;
        //   } else if (layout instanceof BsSplitPane) {
        //     return EPaneType.splitPane;
        //   } else if (layout instanceof BsContentPane) {
        //     return EPaneType.contentPane;
        //   } else if (layout instanceof BsTabGroupPane) {
        //     return EPaneType.tabGroupPane;
        //   } else {
        //     return null;
        //     // throw 'unknown pane type';
        //   }
        // }));
        this.portal = new DomPortal(element);
    }
    get layout() {
        return this.layout$.value;
    }
    set layout(value) {
        console.log('set layout', value);
        this.layout$.next(value);
    }
}
BsDockPaneRendererComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPaneRendererComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component });
BsDockPaneRendererComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.5", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: { layout: "layout" }, ngImport: i0, template: "<!-- <ng-content></ng-content> -->\n<ng-container [bsInstanceof]=\"layout$ | async\">\n    <div *bsInstanceofCase=\"BsDocumentHostType; let documentHost\" data-hello>\n        <bs-dock-pane-renderer [layout]=\"documentHost\"></bs-dock-pane-renderer>\n    </div>\n    <bs-tab-control *bsInstanceofCase=\"BsTabGroupType; let tabGroup\" class=\"d-flex flex-column h-100 dock-tabs\">\n        <bs-tab-page *ngFor=\"let tab of tabGroup.panes\">\n            <ng-container *bsTabPageHeader>\n                <ng-template [cdkPortalOutlet]=\"tab.dockPanel.headerPortal\"></ng-template>\n            </ng-container>\n            <bs-dock-pane-renderer [layout]=\"tab\"></bs-dock-pane-renderer>\n        </bs-tab-page>\n    </bs-tab-control>\n    <bs-splitter *bsInstanceofCase=\"BsSplitterType; let splitter\" [orientation]=\"splitter.orientation\">\n        <bs-split-panel *ngFor=\"let panel of splitter.panes\">\n            <bs-dock-pane-renderer [layout]=\"panel\"></bs-dock-pane-renderer>\n        </bs-split-panel>\n    </bs-splitter>\n    <ng-container *bsInstanceofCase=\"BsContentPaneType; let content\">\n        <ng-template [cdkPortalOutlet]=\"content.dockPanel.contentPortal\"></ng-template>\n    </ng-container>\n    <div *bsInstanceofDefault>\n        No match\n    </div>\n</ng-container>", styles: [".dock-tabs{background:#F3F3F3}:host ::ng-deep .tab-page-content{background:#FFF;min-height:100%}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2$1.CdkPortalOutlet, selector: "[cdkPortalOutlet]", inputs: ["cdkPortalOutlet"], outputs: ["attached"], exportAs: ["cdkPortalOutlet"] }, { kind: "directive", type: i3.BsInstanceOfDirective, selector: "[bsInstanceof]", inputs: ["bsInstanceof"] }, { kind: "directive", type: i3.BsInstanceofCaseDirective, selector: "[bsInstanceofCase]", inputs: ["bsInstanceofCase"] }, { kind: "directive", type: i3.BsInstanceOfDefaultDirective, selector: "[bsInstanceofDefault]" }, { kind: "component", type: i4.BsSplitterComponent, selector: "bs-splitter", inputs: ["orientation"] }, { kind: "component", type: i4.BsSplitPanelComponent, selector: "bs-split-panel" }, { kind: "component", type: i5.BsTabControlComponent, selector: "bs-tab-control", inputs: ["border", "restrictDragging", "selectFirstTab", "tabsPosition"] }, { kind: "component", type: i5.BsTabPageComponent, selector: "bs-tab-page", inputs: ["disabled"] }, { kind: "directive", type: i5.BsTabPageHeaderDirective, selector: "[bsTabPageHeader]" }, { kind: "component", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: ["layout"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPaneRendererComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-pane-renderer', template: "<!-- <ng-content></ng-content> -->\n<ng-container [bsInstanceof]=\"layout$ | async\">\n    <div *bsInstanceofCase=\"BsDocumentHostType; let documentHost\" data-hello>\n        <bs-dock-pane-renderer [layout]=\"documentHost\"></bs-dock-pane-renderer>\n    </div>\n    <bs-tab-control *bsInstanceofCase=\"BsTabGroupType; let tabGroup\" class=\"d-flex flex-column h-100 dock-tabs\">\n        <bs-tab-page *ngFor=\"let tab of tabGroup.panes\">\n            <ng-container *bsTabPageHeader>\n                <ng-template [cdkPortalOutlet]=\"tab.dockPanel.headerPortal\"></ng-template>\n            </ng-container>\n            <bs-dock-pane-renderer [layout]=\"tab\"></bs-dock-pane-renderer>\n        </bs-tab-page>\n    </bs-tab-control>\n    <bs-splitter *bsInstanceofCase=\"BsSplitterType; let splitter\" [orientation]=\"splitter.orientation\">\n        <bs-split-panel *ngFor=\"let panel of splitter.panes\">\n            <bs-dock-pane-renderer [layout]=\"panel\"></bs-dock-pane-renderer>\n        </bs-split-panel>\n    </bs-splitter>\n    <ng-container *bsInstanceofCase=\"BsContentPaneType; let content\">\n        <ng-template [cdkPortalOutlet]=\"content.dockPanel.contentPortal\"></ng-template>\n    </ng-container>\n    <div *bsInstanceofDefault>\n        No match\n    </div>\n</ng-container>", styles: [".dock-tabs{background:#F3F3F3}:host ::ng-deep .tab-page-content{background:#FFF;min-height:100%}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { layout: [{
                type: Input
            }] } });

class BsDockComponent {
    constructor(overlay) {
        this.overlay = overlay;
        //#region Panels
        this.panels$ = new BehaviorSubject([]);
        //#endregion
        this.floating$ = new BehaviorSubject([]);
        this.positionAbsolute = true;
        this.positionPx = 0;
        this.destroyed$ = new Subject();
        const tabs = new BsTabGroupPane();
        const docHost = new BsDocumentHost();
        docHost.rootPane = tabs;
        this.layout$ = new BehaviorSubject({
            rootPane: docHost,
            floatingPanes: []
        });
        // combineLatest([this.layout$, this.panels$])
        //   .pipe(takeUntil(this.destroyed$))
        //   .subscribe(([layout, panels]) => {
        //   })
        this.floating$.pipe(takeUntil(this.destroyed$))
            .subscribe((floating) => {
            floating.forEach((panel) => {
                const overlayRef = this.overlay.create({});
                overlayRef.attach(panel.portal);
            });
        });
    }
    set panels(value) {
        this.panels$.next(value.toArray());
    }
    get layout() {
        return this.layout$.value;
    }
    set layout(value) {
        this.layout$.next(value);
    }
    set floatingPanes(value) {
        // value.changes.pipe(takeUntil(this.destroyed$)).subscribe((changes) => console.log('floatingPanes', changes));
        this.floating$.next(value.toArray());
    }
    ngOnDestroy() {
        this.destroyed$.next(true);
    }
}
BsDockComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockComponent, deps: [{ token: i1.Overlay }], target: i0.ɵɵFactoryTarget.Component });
BsDockComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.5", type: BsDockComponent, selector: "bs-dock", inputs: { layout: "layout" }, host: { properties: { "class.position-absolute": "this.positionAbsolute", "style.top": "this.positionPx", "style.left": "this.positionPx", "style.bottom": "this.positionPx", "style.right": "this.positionPx" } }, queries: [{ propertyName: "panels", predicate: BsDockPanelComponent }], viewQueries: [{ propertyName: "floatingPanes", predicate: ["floating"], descendants: true }], ngImport: i0, template: "<ng-content></ng-content>\n<ng-container *ngIf=\"(layout$ | async) as layout\">\n    <bs-dock-pane-renderer [layout]=\"layout.rootPane\"></bs-dock-pane-renderer>\n\n    <ng-container *ngFor=\"let pane of layout.floatingPanes\">\n        <bs-dock-pane-renderer #floating *ngIf=\"pane.pane\" [layout]=\"pane.pane\"></bs-dock-pane-renderer>\n    </ng-container>\n</ng-container>\n<!-- <bs-splitter>\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let panel of (panels$ | async)\">\n        <bs-split-panel>\n            <ng-template [cdkPortalOutlet]=\"panel.portal\"></ng-template>\n        </bs-split-panel>\n    </ng-container>\n</bs-splitter> -->\n", styles: [":host ::ng-deep .tab-content{max-height:calc(100% - 41px);overflow:auto}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "component", type: BsDockPaneRendererComponent, selector: "bs-dock-pane-renderer", inputs: ["layout"] }, { kind: "pipe", type: i2.AsyncPipe, name: "async" }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock', template: "<ng-content></ng-content>\n<ng-container *ngIf=\"(layout$ | async) as layout\">\n    <bs-dock-pane-renderer [layout]=\"layout.rootPane\"></bs-dock-pane-renderer>\n\n    <ng-container *ngFor=\"let pane of layout.floatingPanes\">\n        <bs-dock-pane-renderer #floating *ngIf=\"pane.pane\" [layout]=\"pane.pane\"></bs-dock-pane-renderer>\n    </ng-container>\n</ng-container>\n<!-- <bs-splitter>\n    <ng-content></ng-content>\n    <ng-container *ngFor=\"let panel of (panels$ | async)\">\n        <bs-split-panel>\n            <ng-template [cdkPortalOutlet]=\"panel.portal\"></ng-template>\n        </bs-split-panel>\n    </ng-container>\n</bs-splitter> -->\n", styles: [":host ::ng-deep .tab-content{max-height:calc(100% - 41px);overflow:auto}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }]; }, propDecorators: { panels: [{
                type: ContentChildren,
                args: [BsDockPanelComponent]
            }], layout: [{
                type: Input
            }], floatingPanes: [{
                type: ViewChildren,
                args: ['floating']
            }], positionAbsolute: [{
                type: HostBinding,
                args: ['class.position-absolute']
            }], positionPx: [{
                type: HostBinding,
                args: ['style.top']
            }, {
                type: HostBinding,
                args: ['style.left']
            }, {
                type: HostBinding,
                args: ['style.bottom']
            }, {
                type: HostBinding,
                args: ['style.right']
            }] } });

class BsFloatingPane {
    constructor(data) {
        Object.assign(this, data);
    }
}

class BsDockPanelHeaderComponent {
    constructor(overlay, dockPanel, dock) {
        this.overlay = overlay;
        this.dockPanel = dockPanel;
        this.dock = dock;
        this.isDragging = false;
        this.isLayoutDetached = false;
        this.dBlock = true;
        this.overlayRef = this.overlay.create({
            positionStrategy: this.overlay.position().global()
        });
    }
    onMouseDown(ev) {
        ev.preventDefault();
        this.isDragging = true;
    }
    onMouseMove(ev) {
        if (this.isDragging) {
            if (!this.isLayoutDetached) {
                this.isLayoutDetached = true;
                this.dock.layout$.subscribe((layout) => {
                    layout.floatingPanes.push(new BsFloatingPane({
                        pane: new BsTabGroupPane({
                            panes: [
                                new BsContentPane({
                                    dockPanel: this.dockPanel
                                })
                            ]
                        })
                    }));
                });
            }
        }
    }
    onMouseUp(ev) {
        this.isDragging = false;
    }
}
BsDockPanelHeaderComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPanelHeaderComponent, deps: [{ token: i1.Overlay }, { token: BsDockPanelComponent }, { token: BsDockComponent }], target: i0.ɵɵFactoryTarget.Component });
BsDockPanelHeaderComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "15.2.5", type: BsDockPanelHeaderComponent, selector: "bs-dock-panel-header", host: { listeners: { "mousedown": "onMouseDown($event)", "document:mousemove": "onMouseMove($event)", "document:mouseup": "onMouseUp($event)" }, properties: { "class.d-block": "this.dBlock" } }, ngImport: i0, template: "<ng-content></ng-content>", styles: [":host{padding:var(--bs-nav-link-padding-y) var(--bs-nav-link-padding-x);margin:calc(-1 * var(--bs-nav-link-padding-y)) calc(-1 * var(--bs-nav-link-padding-x))}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockPanelHeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-dock-panel-header', template: "<ng-content></ng-content>", styles: [":host{padding:var(--bs-nav-link-padding-y) var(--bs-nav-link-padding-x);margin:calc(-1 * var(--bs-nav-link-padding-y)) calc(-1 * var(--bs-nav-link-padding-x))}\n"] }]
        }], ctorParameters: function () { return [{ type: i1.Overlay }, { type: BsDockPanelComponent }, { type: BsDockComponent }]; }, propDecorators: { onMouseDown: [{
                type: HostListener,
                args: ['mousedown', ['$event']]
            }], onMouseMove: [{
                type: HostListener,
                args: ['document:mousemove', ['$event']]
            }], onMouseUp: [{
                type: HostListener,
                args: ['document:mouseup', ['$event']]
            }], dBlock: [{
                type: HostBinding,
                args: ['class.d-block']
            }] } });

class BsDockModule {
}
BsDockModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsDockModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.2.5", ngImport: i0, type: BsDockModule, declarations: [BsDockComponent,
        BsDockPanelComponent,
        BsDockPanelHeaderComponent,
        BsDockPaneRendererComponent], imports: [CommonModule,
        PortalModule,
        BsCardModule,
        BsInstanceOfModule,
        BsSplitterModule,
        BsTabControlModule], exports: [BsDockComponent,
        BsDockPanelComponent,
        BsDockPanelHeaderComponent,
        BsDockPaneRendererComponent] });
BsDockModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockModule, imports: [CommonModule,
        PortalModule,
        BsCardModule,
        BsInstanceOfModule,
        BsSplitterModule,
        BsTabControlModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.2.5", ngImport: i0, type: BsDockModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsDockComponent,
                        BsDockPanelComponent,
                        BsDockPanelHeaderComponent,
                        BsDockPaneRendererComponent
                    ],
                    imports: [
                        CommonModule,
                        PortalModule,
                        BsCardModule,
                        BsInstanceOfModule,
                        BsSplitterModule,
                        BsTabControlModule
                    ],
                    exports: [
                        BsDockComponent,
                        BsDockPanelComponent,
                        BsDockPanelHeaderComponent,
                        BsDockPaneRendererComponent
                    ]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsContentPane, BsDockComponent, BsDockModule, BsDockPane, BsDockPaneRendererComponent, BsDockPanelComponent, BsDockPanelHeaderComponent, BsDocumentHost, BsFloatingPane, BsSplitPane, BsTabGroupPane, EPaneType };
//# sourceMappingURL=mintplayer-ng-bootstrap-dock.mjs.map
